/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.32 by edhill, Wed Nov 12 22:05:47 2003 UTC revision 1.61 by edhill, Thu Jan 15 04:27:39 2004 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          echo -n "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 73  find_possible_configs()  { Line 78  find_possible_configs()  {
78      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
79      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
80      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
81      PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
82        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
83        PLATFORM=$tmp2
84      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
85      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
 #     if test "x$OFLIST" = x ; then  
 #       echo "  No pre-defined options files were found matching this platform"  
 #       echo "  but examples for other platforms can be found in:"  
 #       echo "    $ROOTDIR/tools/build_options"  
 #     else  
 #       echo "  Options files (located in $ROOTDIR/tools/build_options) that"  
 #       echo "  may work with this machine are:"  
 #       for i in $OFLIST ; do  
 #           echo "    $i"  
 #       done  
 #     fi  
86            
87      echo "test" > test      echo "test" > test
88      ln -s ./test link      ln -s ./test link
# Line 104  find_possible_configs()  { Line 100  find_possible_configs()  {
100          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
101      fi      fi
102    
103        # makedepend is not always available
104        if test "x${MAKEDEPEND}" = x ; then
105          which makedepend >& /dev/null
106          RETVAL=$?
107          if test "x${RETVAL}" = x1 ; then
108             echo "    makedepend was not found. Using xmakedpend instead."
109             MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
110          fi
111        fi
112    
113      # look for possible fortran compilers      # look for possible fortran compilers
114      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
115      p_FC=      p_FC=
# Line 206  get_pdepend_list()  { Line 212  get_pdepend_list()  {
212      cat $1 | sed -e 's/#.*$//g' \      cat $1 | sed -e 's/#.*$//g' \
213          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
214          > ./.pd_tmp          > ./.pd_tmp
215      source ./.pd_tmp      . ./.pd_tmp
216      rm -f ./.pd_tmp      rm -f ./.pd_tmp
217    
218      echo -n "PNAME = "${}      echo -n "PNAME = "${}
# Line 215  get_pdepend_list()  { Line 221  get_pdepend_list()  {
221    
222  #  Explain usage  #  Explain usage
223  usage()  {  usage()  {
224      echo  cat <<EOF
225      echo "Usage: "$0" [OPTIONS]"  
226      echo "  where [OPTIONS] can be:"  Usage: "$0" [OPTIONS]
227      echo    where [OPTIONS] can be:
228      echo "    -help | --help | -h | --h"  
229      echo "    -nooptfile | --nooptfile"      -help | --help | -h | --h
230      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"            Print this help message and exit.
231      echo "      -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"  
232      echo "    -pdepend NAME | --pdepend NAME"      -nooptfile | --nooptfile
233      echo "      -pdepend=NAME | --pdepend=NAME"        -optfile NAME | --optfile NAME | -of NAME | --of NAME
234      echo "    -pdefault NAME | --pdefault NAME"        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
235      echo "      -pdefault=NAME | --pdefault=NAME"            Use "NAME" as the optfile.  By default, an attempt will be
236      echo "    -make NAME | -m NAME"            made to find an appropriate "standard" optfile in the
237      echo "      --make=NAME | -m=NAME"            tools/build_options/ directory.
238      echo "    -makefile NAME | -mf NAME"  
239      echo "      --makefile=NAME | -mf=NAME"      -pdepend NAME | --pdepend NAME
240      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"        -pdepend=NAME | --pdepend=NAME
241      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"            Get package dependency information from "NAME".
242      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"  
243      echo "      -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"      -pdefault NAME | --pdefault NAME
244      echo "    -mods NAME | --mods NAME | -mo NAME | --mo NAME"        -pdefault=NAME | --pdefault=NAME
245      echo "      -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"            Get the default package list from "NAME".
246      echo "    -disable NAME | --disable NAME"  
247      echo "      -disable=NAME | --disable=NAME"      -make NAME | -m NAME
248      echo "    -enable NAME | --enable NAME"        --make=NAME | -m=NAME
249      echo "      -enable=NAME | --enable=NAME"            Use "NAME" for the MAKE program. The default is "make" but
250      echo "    -standarddirs NAME | --standarddirs NAME"            many platforms, "gmake" is the preferred choice.
251      echo "      -standarddirs=NAME | --standarddirs=NAME"  
252      echo "    -noopt NAME | --noopt NAME"      -makefile NAME | -mf NAME
253      echo "      -noopt=NAME | --noopt=NAME"        --makefile=NAME | -mf=NAME
254  #    echo "    -cpp NAME | --cpp NAME"            Call the makefile "NAME".  The default is "Makefile".
255  #    echo "      -cpp=NAME | --cpp=NAME"  
256      echo "    -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
257      echo "      -fc=NAME | --fc=NAME"        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
258      echo "    -[no]ieee | --[no]ieee"            Specify the location of the MITgcm ROOTDIR as "NAME".
259      echo "    -[no]mpi | --[no]mpi"            By default, genamke will try to find the location by
260      echo "    -[no]jam | --[no]jam"            looking in parent directories (up to the 5th parent).
261      echo  
262      echo "  and NAME is a string such as:"      -mods NAME | --mods NAME | -mo NAME | --mo NAME
263      echo        -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
264      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"            Here, "NAME" specifies a list of directories that are
265      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"            used for additional source code.  Files found in the
266      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"            "mods list" are given preference over files of the same
267      echo            name found elsewhere.
268      echo "  which, depending upon your shell, may need to be single-quoted"  
269      echo "  if it contains spaces, dashes, or other special characters."      -disable NAME | --disable NAME
270          -disable=NAME | --disable=NAME
271              Here "NAME" specifies a list of packages that we don't
272              want to use.  If this violates package dependencies,
273              genamke will exit with an error message.
274    
275        -enable NAME | --enable NAME
276          -enable=NAME | --enable=NAME
277              Here "NAME" specifies a list of packages that we wish
278              to specifically enable.  If this violates package
279              dependencies, genamke will exit with an error message.
280    
281        -standarddirs NAME | --standarddirs NAME
282          -standarddirs=NAME | --standarddirs=NAME
283              Here, "NAME" specifies a list of directories to be
284              used as the "standard" code.
285    
286        -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
287          -fc=NAME | --fc=NAME
288              Use "NAME" as the fortran compiler.  By default, genmake
289              will search for a working compiler by trying a list of
290              "usual suspects" such as g77, f77, etc.
291    
292        -[no]ieee | --[no]ieee
293              Do or don't use IEEE numerics.  Note that this option
294              *only* works if it is supported by the OPTFILE that
295              is being used.
296    
297      While it is most often a single word, the "NAME" variables specified
298      above can in many cases be a space-delimited string such as:
299    
300        --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'
301        -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'
302        -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
303    
304      which, depending upon your shell, may need to be single-quoted.
305    
306      For more detailed genmake documentation, please see:
307    
308        http://mitgcm.org/devel_HOWTO/
309    
310    EOF
311    
312      exit 1      exit 1
313  }  }
314    
# Line 271  get_fortran_c_namemangling()  { Line 319  get_fortran_c_namemangling()  {
319      cat > genmake_test.c <<EOF      cat > genmake_test.c <<EOF
320  void tcall( char * string ) { tsub( string ); }  void tcall( char * string ) { tsub( string ); }
321  EOF  EOF
322      $MAKE genmake_test.o > genmake_test.log 2>&1      $MAKE genmake_test.o >> genmake_warnings 2>&1
323      RETVAL=$?      RETVAL=$?
324      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
         cat genmake_test.log >> genmake_errors  
325          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
326          echo          cat <<EOF>> genmake_errors
327          echo "WARNING: C test compile fails -- please see \"genmake_errors\""  
328          echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"  WARNING: C test compile fails
329          echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
330    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
331    EOF
332          return 1          return 1
333      fi      fi
334      c_tcall=`nm genmake_test.o | grep tcall | cut -d ' ' -f 3`      c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
335      RETVAL=$?      RETVAL=$?
336      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
337          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
338          echo          cat <<EOF>> genmake_warnings
339          echo "WARNING: The \"nm\" command failed."  
340          echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"  WARNING: The "nm" command failed.
341          echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
342    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
343    EOF
344          return 1          return 1
345      fi      fi
346      cat > genmake_tcomp.f <<EOF      cat > genmake_tcomp.f <<EOF
# Line 298  EOF Line 349  EOF
349        call tsub( string )        call tsub( string )
350        end        end
351  EOF  EOF
352      $FC $FFLAGS $DEFINES -c genmake_tcomp.f > genmake_tcomp.log 2>&1      $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1
353      RETVAL=$?      RETVAL=$?
354      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
         cat genmake_tcomp.log >> genmake_errors  
355          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
356          echo          cat <<EOF>> genmake_warnings
357          echo "WARNING: FORTRAN test compile fails -- please see \"genmake_errors\""  
358          echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"  WARNING: FORTRAN test compile fails -- please see "genmake_errors"
359          echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
360    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
361    EOF
362          return 1          return 1
363      fi      fi
364      f_tcall=`nm genmake_tcomp.o | grep tcall | cut -d ' ' -f 3`      f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
365      RETVAL=$?      RETVAL=$?
366      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
367          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
368          echo          cat <<EOF>> genmake_warnings
369          echo "WARNING: The \"nm\" command failed."  
370          echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"  WARNING: The "nm" command failed.
371          echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
372    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
373    EOF
374          return 1          return 1
375      fi      fi
376    
# Line 343  EOF Line 397  EOF
397      rm -f genmake_tcomp.* genmake_test.*      rm -f genmake_tcomp.* genmake_test.*
398  }  }
399    
400    
401    check_HAVE_CLOC()  {
402        get_fortran_c_namemangling
403        cat <<EOF > genmake_tc_1.c
404    $FC_NAMEMANGLE
405    #include <stdio.h>
406    #include <stdlib.h>
407    #include <unistd.h>
408    #include <assert.h>
409    #include <sys/time.h>
410    void FC_NAMEMANGLE(cloc) ( double *curtim )
411    {
412     struct timeval tv1;
413     gettimeofday(&tv1 , (void *)NULL );
414     *curtim =  (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
415     *curtim = *curtim/1.E6;
416    }
417    EOF
418        make genmake_tc_1.o >> genmake_tc.log 2>&1
419        RET_C=$?
420        cat <<EOF > genmake_tc_2.f
421          program hello
422          Real*8 wtime
423          external cloc
424          call cloc(wtime)
425          print *," HELLO WORLD", wtime
426          end program hello
427    EOF
428        $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1
429        RET_F=$?
430        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
431        RETVAL=$?
432        if test "x$RETVAL" = x0 ; then
433            HAVE_CLOC=t
434            DEFINES="$DEFINES -DHAVE_CLOC"
435        fi
436        rm -f genmake_tc*
437    }
438    
439    
440    check_netcdf_libs()  {
441        cat <<EOF > genmake_tnc.F
442          program fgennc
443    #include "netcdf.inc"
444          integer iret, ncid, xid
445          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
446          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
447          iret = nf_def_dim(ncid, 'X', 11, xid)
448          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
449          iret = nf_close(ncid)
450          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
451          end
452    EOF
453        $CPP genmake_tnc.F > genmake_tnc.f  \
454            &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
455        RET_COMPILE=$?
456        test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
457        RETVAL=$?
458        if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
459            HAVE_NETCDF=t
460        else
461            cat genmake_tnc.log >> genmake_warnings
462        fi
463        rm -f genmake_tnc*
464    }
465    
466    
467  #  Set defaults here  #  Set defaults here
468  COMMANDL="$0 $@"  COMMANDL="$0 $@"
469    
# Line 351  LN= Line 472  LN=
472  S64=  S64=
473  KPP=  KPP=
474  FC=  FC=
475    CPP=
476  LINK=  LINK=
477  # DEFINES="-DWORDLENGTH=4"  # DEFINES="-DWORDLENGTH=4"
478  DEFINES=  DEFINES=
# Line 378  NOOPTFLAGS= Line 500  NOOPTFLAGS=
500  HAVE_SYSTEM=  HAVE_SYSTEM=
501  HAVE_FDATE=  HAVE_FDATE=
502  FC_NAMEMANGLE=  FC_NAMEMANGLE=
503    HAVE_CLOC=
504    HAVE_NETCDF=
505    
506  MODS=  MODS=
507  TOOLSDIR=  TOOLSDIR=
508  SOURCEDIRS=  SOURCEDIRS=
509  INCLUDEDIRS=  INCLUDEDIRS=
510  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
511    
512  PWD=`pwd`  PWD=`pwd`
513  MAKE=make  MAKE=make
# Line 416  TAMC_EXTRA= Line 540  TAMC_EXTRA=
540    
541    
542  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
543  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
544  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
545    
546  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
547  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
# Line 434  gm_s12="TAF_EXTRA TAMC_EXTRA" Line 558  gm_s12="TAF_EXTRA TAMC_EXTRA"
558  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
559  gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"  gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
560    
561    cat <<EOF
562    
563    GENMAKE :
564    
565    A program for GENerating MAKEfiles for the MITgcm project.  For a
566    quick list of options, use "genmake -h" or for more detail see:
567    
568      http://mitgcm.org/devel_HOWTO/
569    
570    EOF
571    
 echo  
572  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
573  gm_local="genmake_local"  gm_local="genmake_local"
574  for i in . $MODS ; do  for i in . $MODS ; do
575      if test -r $i/$gm_local ; then      if test -r $i/$gm_local ; then
576          source $i/$gm_local          . $i/$gm_local
577          break          break
578      fi      fi
579  done  done
580  echo -n "  getting local config information:  "  echo -n "  getting local config information:  "
581  if test -e $gm_local ; then  if test -e $gm_local ; then
582      echo "using $gm_local"      echo "using $gm_local"
583      source $gm_local      . $gm_local
584      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
585      # echo "ENABLE=$ENABLE"      # echo "ENABLE=$ENABLE"
586  else  else
# Line 489  for ac_option ; do Line 622  for ac_option ; do
622          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
623              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
624                    
625          -adoptfile | --adoptfile | -ad | --ad)          -adoptfile | --adoptfile | -adof | --adof)
626              ac_prev=AD_OPTFILE ;;              ac_prev=AD_OPTFILE ;;
627          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
628              AD_OPTFILE=$ac_optarg ;;              AD_OPTFILE=$ac_optarg ;;
# Line 514  for ac_option ; do Line 647  for ac_option ; do
647          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
648              MAKEFILE=$ac_optarg ;;              MAKEFILE=$ac_optarg ;;
649                    
650          -platform | --platform | -pl | --pl)          -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
651              ac_prev=PLATFORM ;;              echo "ERROR: The platform option has been removed.  Please specify"
652          -platform=* | --platform=* | -pl=* | --pl=*)              echo "  the build options using the \"optfile\" mechanism."
653              PLATFORM=$ac_optarg ;;              echo
654                usage
655                ;;
656                    
657          -rootdir | --rootdir | -rd | --rd)          -rootdir | --rootdir | -rd | --rd)
658              ac_prev=ROOTDIR ;;              ac_prev=ROOTDIR ;;
# Line 544  for ac_option ; do Line 679  for ac_option ; do
679          -standarddirs=* | --standarddirs=*)          -standarddirs=* | --standarddirs=*)
680              STANDARDDIRS=$ac_optarg ;;              STANDARDDIRS=$ac_optarg ;;
681    
         -noopt | --noopt)  
             ac_prev=NOOPT ;;  
         -noopt=* | --noopt=*)  
             NOOPT=$ac_optarg ;;  
           
682  #           -cpp | --cpp)  #           -cpp | --cpp)
683  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
684  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
# Line 564  for ac_option ; do Line 694  for ac_option ; do
694          -noieee | --noieee)          -noieee | --noieee)
695              IEEE= ;;              IEEE= ;;
696                    
697          -mpi | --mpi)  #       -jam | --jam)
698              MPI=true ;;  #           JAM=1 ;;
699          -nompi | --nompi)  #       -nojam | --nojam)
700              MPI= ;;  #           JAM=0 ;;
           
         -jam | --jam)  
             JAM=1 ;;  
         -nojam | --nojam)  
             JAM=0 ;;  
701                    
702          -ds | --ds)          -ds | --ds)
703              DUMPSTATE=t ;;              DUMPSTATE=t ;;
# Line 651  fi Line 776  fi
776  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
777      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
778          echo "    using OPTFILE=\"$OPTFILE\""          echo "    using OPTFILE=\"$OPTFILE\""
779          source "$OPTFILE"          . "$OPTFILE"
780          RETVAL=$?          RETVAL=$?
781          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
782              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""
# Line 678  fi Line 803  fi
803  if test "x${AD_OPTFILE}" != xNONE ; then  if test "x${AD_OPTFILE}" != xNONE ; then
804      if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then      if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
805          echo "    using AD_OPTFILE=\"$AD_OPTFILE\""          echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
806          source "$AD_OPTFILE"          . "$AD_OPTFILE"
807          RETVAL=$?          RETVAL=$?
808          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
809              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
# Line 694  if test "x${AD_OPTFILE}" != xNONE ; then Line 819  if test "x${AD_OPTFILE}" != xNONE ; then
819      fi      fi
820  fi  fi
821    
822  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
823  #  and abort!  #  either set defaults or complain and abort!
824  if test "x$FC" = x ; then  if test "x$FC" = x ; then
825      cat <<EOF 1>&2      cat <<EOF 1>&2
826    
# Line 712  fi Line 837  fi
837  if test "x$CPP" = x ; then  if test "x$CPP" = x ; then
838      CPP="cpp"      CPP="cpp"
839  fi  fi
840    if test "x$MAKE" = x ; then
841        MAKE="make"
842    fi
843  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
844  RETVAL=$?  RETVAL=$?
845  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 731  fi Line 859  fi
859  if test "x$MAKEDEPEND" = x ; then  if test "x$MAKEDEPEND" = x ; then
860      MAKEDEPEND=makedepend      MAKEDEPEND=makedepend
861  fi  fi
862    if test "x$LN" = x ; then
863        LN="ln -s"
864    fi
865    echo "test" > genmake_test_ln
866    $LN genmake_test_ln genmake_tlink
867    RETVAL=$?
868    if test "x$RETVAL" != x0 ; then
869        cat <<EOF 1>&2
870    
871    Error: The command "ln -s" failed -- please specify a working soft-link
872      command in the optfile.
873    
874    EOF
875        exit 1
876    fi
877    rm -f genmake_test_ln genmake_tlink
878    
879    
880  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
# Line 773  else Line 917  else
917  fi  fi
918  rm -f genmake_tcomp*  rm -f genmake_tcomp*
919    
920  echo "  The name mangling convention for $FC is...  "  echo -n "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
921  #FC_NAMEMANGLE="#define FC_NAMEMANGLE(X) X ## _"  check_HAVE_CLOC
922  if test "x$FC_NAMEMANGLE" = x ; then  if test "x$HAVE_CLOC" != x ; then
923      get_fortran_c_namemangling      echo "yes"
924    else
925        echo "no"
926  fi  fi
927  echo "    '$FC_NAMEMANGLE'"  rm -f genmake_t*
928  echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template  
929  cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1  echo -n "  Can we create NetCDF-enabled binaries...  "
930  RETVAL=$?  check_netcdf_libs
931  if test "x$RETVAL" != x0 ; then  if test "x$HAVE_NETCDF" != x ; then
932      mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h      echo "yes"
933    else
934        echo "no"
935  fi  fi
936    
937    
# Line 831  fi Line 979  fi
979  if test "x$S64" = x ; then  if test "x$S64" = x ; then
980      S64='$(TOOLSDIR)/set64bitConst.sh'      S64='$(TOOLSDIR)/set64bitConst.sh'
981  fi  fi
982    THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
983    
984  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
985    
# Line 839  EXECUTABLE=${EXECUTABLE:-mitgcmuv} Line 988  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
988  #  they appear as regular source code  #  they appear as regular source code
989  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
990      echo "  Making source files in eesupp from templates"      echo "  Making source files in eesupp from templates"
991      $MAKE -C $ROOTDIR"/eesupp/src/" > make_eesupp.errors 2>&1      ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
992      RETVAL=$?      RETVAL=$?
993      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
994          rm -f make_eesupp.errors          rm -f make_eesupp.errors
# Line 850  if test -r $ROOTDIR"/eesupp/src/Makefile Line 999  if test -r $ROOTDIR"/eesupp/src/Makefile
999      fi      fi
1000  fi  fi
1001    
1002    #same for exch2
1003    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1004        echo "  Making source files in exch2 from  templates"
1005        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1006        RETVAL=$?
1007        if test "x${RETVAL}" = x0 ; then
1008            rm -f make_exch2.errors
1009        else
1010            echo "Error: problem encountered while building source files in exch2:"
1011            cat make_exch2.errors
1012            exit 1
1013        fi
1014    fi
1015    
1016  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1017  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1018      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 876  if test ! "x${RETVAL}" = x0 ; then Line 1039  if test ! "x${RETVAL}" = x0 ; then
1039      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
1040      exit 1      exit 1
1041  fi  fi
1042  source ./.pd_tmp  . ./.pd_tmp
1043  rm -f ./.pd_tmp  rm -f ./.pd_tmp
1044    
1045  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
1046  #  file should eventually be added so that, for convenience, one can  #  file should eventually be added so that, for convenience, one can
1047  #  specify groups of packages using names like "ocean" and "atmosphere".  #  specify groups of packages using names like "ocean" and "atmosphere".
1048  echo  -n "  checking default package list:  "  echo "  checking default package list:  "
1049  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
1050      for i in "." $MODS ; do      for i in "." $MODS ; do
1051          if test -r $i"/packages.conf" ; then          if test -r $i"/packages.conf" ; then
# Line 895  if test "x${PDEFAULT}" = x ; then Line 1058  if test "x${PDEFAULT}" = x ; then
1058      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
1059  fi  fi
1060  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
1061      echo "default packages file disabled"      echo "    default packages file disabled"
1062  else  else
1063      if test ! -r $PDEFAULT ; then      if test ! -r $PDEFAULT ; then
         echo ""  
1064          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""
1065      else      else
1066          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "    using PDEFAULT=\"$PDEFAULT\""
1067          #  Strip the comments and add all the names          #  Strip the comments and add all the names
1068          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1069          RETVAL=$?          RETVAL=$?
# Line 1034  for i in $PACKAGES ; do Line 1196  for i in $PACKAGES ; do
1196      fi      fi
1197  done  done
1198    
1199    #  Check for ability to build and use NetCDF
1200    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1201    RETVAL=$?
1202    if test "x$RETVAL" = x0 -a "x$HAVE_NETCDF" != xt ; then
1203        cat <<EOF
1204    
1205  # Create a list of #define and #undef to enable/disable packages  WARNING: the "mnc" package has been enabled but tests failed to
1206  PACKAGES_DOT_H=PACKAGES_CONFIG.h    compile and/or execute NetCDF applications.  Please check that:
 cat <<EOF >$PACKAGES_DOT_H".tmp"  
 C=== GENMAKE v2 ===  
 C  The following defines have been set by GENMAKE, so please do not  
 C  edit anything below these comments.  In general, you should  
 C  add or remove packages by re-running genmake with different  
 C  "-enable" and/or "-disable" options.  
   
 #ifndef PACKAGES_H  
 #define PACKAGES_H  
1207    
1208  C  Packages disabled by genmake:    1) NetCDF is installed for your compiler and
1209      2) the LIBS variable (within the 'optfile") specifies the correct
1210           NetCDF library to link against.
1211      
1212  EOF  EOF
1213    fi
1214    
1215    # Create a list of #define and #undef to enable/disable packages
1216    PACKAGES_DOT_H=PACKAGES_CONFIG.h
1217  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
1218  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1219  #  file would eventually be split up so that all package-related #define  #  file would eventually be split up so that all package-related #define
1220  #  statements could be separated and handled only by genmake.  #  statements could be separated and handled only by genmake.
1221  names=`ls -1 "$ROOTDIR/pkg"`  names=`ls -1 "$ROOTDIR/pkg"`
1222  all_pack=  all_pack=
1223    DISABLED_PACKAGES=
1224  for n in $names ; do  for n in $names ; do
1225      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1226          has_pack="f"          has_pack="f"
# Line 1066  for n in $names ; do Line 1232  for n in $names ; do
1232          done          done
1233          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1234              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1235              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
1236          fi          fi
1237      fi      fi
1238  done  done
1239  cat <<EOF >>$PACKAGES_DOT_H".tmp"  ENABLED_PACKAGES=
   
 C  Packages enabled by genmake:  
 EOF  
1240  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1241      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1242      echo "#define $def" >> $PACKAGES_DOT_H".tmp"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1243  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
1244    
1245  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1246      case $i in      case $i in
1247          aim_v23)          aim_v23)
1248              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1249              DEFINES="$DEFINES -DALLOW_AIM"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
             echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"  
1250              ;;              ;;
1251      esac      esac
1252  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1253    
1254  done  done
 cat <<EOF >>$PACKAGES_DOT_H".tmp"  
   
 #endif /* PACKAGES_H */  
 EOF  
   
 if test ! -f $PACKAGES_DOT_H ; then  
     mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
 else  
     cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     RETVAL=$?  
     if test "x$RETVAL" = x0 ; then  
         rm -f $PACKAGES_DOT_H".tmp"  
     else  
         mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"  
         mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     fi  
 fi  
1255    
1256  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1257  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1258  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1259      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1260  fi  fi
1261  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1262      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1263      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1264          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1265          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1266          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1267      else              exit 1
1268          SOURCEDIRS="$SOURCEDIRS $adr"          else
1269      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1270      adr="$ROOTDIR/$d/inc"          fi
1271      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1272          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1273          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1274          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1275      else              exit 1
1276          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1277      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1278  done          fi
1279        done
1280    fi
1281    
1282  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1283  echo "    of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1284  CPP_OPTIONS=  CPP_OPTIONS=
1285    CPP_EEOPTIONS=
1286  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1287    names=`ls -1 "$ROOTDIR/pkg"`
1288  for i in $spaths ; do  for i in $spaths ; do
1289      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1290      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1291          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1292          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1293          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1294            for n in $names ; do
1295                test_for_package_in_cpp_options $CPP_OPTIONS $n
1296            done
1297        fi
1298        try="$i/CPP_EEOPTIONS.h"
1299        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1300            echo "    found CPP_EEOPTIONS=\"$try\""
1301            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1302    #**** not yet enabled ****
1303    #        test_for_mpi_in_cpp_eeoptions $try
1304    #**** not yet enabled ****
1305            CPP_EEOPTIONS="$try"
1306      fi      fi
1307  done  done
1308  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1309      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1310      exit 1      exit 1
1311  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1312    
1313  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1314  #  compiler.  #  compiler.
# Line 1169  for i in $SOURCEDIRS ; do Line 1323  for i in $SOURCEDIRS ; do
1323      done      done
1324  done  done
1325    
 cat <<EOF > adjoint_sed  
 s/call adopen(/call adopen ( mythid,\\  
      \&           /g  
 s/call adclose(/call adclose( mythid,\\  
      \&           /g  
 s/call adread(/call adread ( mythid,\\  
      \&           /g  
 s/call adwrite(/call adwrite( mythid,\\  
      \&           /g  
   
 EOF  
1326    
1327  echo  echo
1328  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
# Line 1210  for d in $alldirs ; do Line 1353  for d in $alldirs ; do
1353      for sf in $sfiles ; do      for sf in $sfiles ; do
1354          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1355              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1356                    case $d/$sf in
1357                      ./$PACKAGES_DOT_H)
1358                            ;;
1359                      ./AD_CONFIG.h)
1360                            ;;
1361                      ./FC_NAMEMANGLE.h)
1362                            ;;
1363                      *)
1364                            touch .links.tmp/$sf
1365                            deplist="$deplist $sf"
1366                            ;;
1367                    esac
1368                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`
                 touch .links.tmp/$sf  
                 deplist="$deplist $sf"  
1369                  case $extn in                  case $extn in
1370                      F)                      F)
1371                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
# Line 1270  EXE_FTL=$EXECUTABLE"_ftl" Line 1423  EXE_FTL=$EXECUTABLE"_ftl"
1423  EXE_SVD=$EXECUTABLE"_svd"  EXE_SVD=$EXECUTABLE"_svd"
1424    
1425  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1426    #
1427    # OPTFILE="$OPTFILE"
1428  #  #
1429  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1430  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1303  EXE_AD      = ${EXE_AD} Line 1458  EXE_AD      = ${EXE_AD}
1458  EXE_FTL     = ${EXE_FTL}  EXE_FTL     = ${EXE_FTL}
1459  EXE_SVD     = ${EXE_SVD}  EXE_SVD     = ${EXE_SVD}
1460    
1461    ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1462    DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1463    
1464    # These files are created by Makefile
1465    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1466    
1467  EOF  EOF
1468    
1469  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1367  cat >>$MAKEFILE <<EOF Line 1528  cat >>$MAKEFILE <<EOF
1528  .SUFFIXES: .o .f .p .F .c .F90 .f90  .SUFFIXES: .o .f .p .F .c .F90 .f90
1529    
1530  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1531  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1532            @echo Creating \$@ ...
1533          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1534  depend:  depend:
1535          @make links          @make links
1536          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1537          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1538    
1539  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1540    
1541  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1542    
# Line 1383  output.txt: \$(EXECUTABLE) Line 1545  output.txt: \$(EXECUTABLE)
1545          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1546    
1547  clean:  clean:
1548          -cat AD_CONFIG.template > AD_CONFIG.h          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template
         -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}  
1549  Clean:  Clean:
1550          @make clean          @make clean
1551          @make cleanlinks          @make cleanlinks
1552          -rm -f Makefile.bak genmake_state genmake_*optfile make.log          -rm -f \$(SPECIAL_FILES)
1553            -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1554  CLEAN:  CLEAN:
1555          @make Clean          @make Clean
1556          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
# Line 1398  CLEAN: Line 1560  CLEAN:
1560    
1561  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1562  makefile:  makefile:
1563          ${0} $@          $THIS_SCRIPT $@
1564  cleanlinks:  cleanlinks:
1565          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1566    
1567    # Special targets ($SPECIAL_FILES) which are create by make
1568    ${PACKAGES_DOT_H}:
1569            @echo Creating \$@ ...
1570            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1571    AD_CONFIG.h:
1572            @echo Creating \$@ ...
1573            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1574    FC_NAMEMANGLE.h:
1575            @echo Creating \$@ ...
1576            echo "$FC_NAMEMANGLE" > \$@
1577    
1578  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .f - .o  )
1579  .F.f:  .F.f:
1580          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
# Line 1461  adtaf: ad_taf_output.f Line 1634  adtaf: ad_taf_output.f
1634  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
1635    
1636  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1637            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1638          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1639            -rm -f ad_config.template
1640          @make \$(F77FILES)          @make \$(F77FILES)
1641          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1642          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1643    
1644  ad_taf_output.f: ad_input_code.f  ad_taf_output.f: ad_input_code.f
1645          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1646          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1647    
1648    adtafonly:
1649            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1650            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1651    
1652  ad_taf: ad_taf_output.o \$(OBJFILES)  ad_taf: ad_taf_output.o \$(OBJFILES)
1653          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1654    
1655  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.f: ad_input_code.f
1656          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
1657          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f
1658    
1659  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
1660          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
# Line 1487  ftltaf: ftl_taf_output.f Line 1666  ftltaf: ftl_taf_output.f
1666  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
1667    
1668  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1669            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1670          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1671            -rm -f ftl_config.template
1672          @make \$(F77FILES)          @make \$(F77FILES)
1673          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1674          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
1675    
1676  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.f: ftl_input_code.f
1677          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1678          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1679    
1680    ftltafonly:
1681            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1682            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1683    
1684  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
1685          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
1686    
1687  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.f: ftl_input_code.f
1688          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
1689          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f
1690    
1691  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
1692          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
1693    
1694    
1695  # ... SVD ...  # ... SVD ...
1696  svd: svd_taf  svdtaf: ad_taf_output.f ftl_taf_output.f
1697  svd_taf_f: svd_taf_output.f  svdall: svd_taf
1698    
1699  svd_input_code.f: \$(SRCFILES)  svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)
1700          cmp svd_config.template AD_CONFIG.h || cat svd_config.template > AD_CONFIG.h          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
         @make \$(F77FILES)  
         @make \$(AD_FLOW_FILES)  
         cat \$(AD_FLOW_FILES) \$(AD_FILES) > svd_input_code.f  
   
 svd_taf_output.f: svd_input_code.f  
         \$(TAF) \$(SVD_TAF_FLAGS) \$(TAF_EXTRA) svd_input_code.f  
         cat svd_input_code_ad.f | sed -f adjoint_sed > svd_taf_output.f  
   
 svd_taf: svd_taf_output.o \$(OBJFILES)  
         \$(LINK) -o ${EXE_SVD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) svd_taf_output.o \$(LIBS)  
1701    
1702    
1703  #=========================================  #=========================================
# Line 1563  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 1738  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
1738    
1739  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
1740    
1741  #  Write the "template" files for the adjoint builds  # Create special header files
1742  cat >AD_CONFIG.template <<EOF  $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
1743  C  WARNING: This file is automatically generated by genmake2 and  if test ! -f $PACKAGES_DOT_H ; then
1744  C    used by the Makefile rules.  Please DO NOT EDIT this file      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1745  C    unless you are CERTAIN that you know what you are doing.  else
1746        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
1747  #undef ALLOW_ADJOINT_RUN      RETVAL=$?
1748  #undef ALLOW_TANGENTLINEAR_RUN      if test "x$RETVAL" = x0 ; then
1749  #undef ALLOW_ECCO_OPTIMIZATION          rm -f $PACKAGES_DOT_H".tmp"
1750  EOF      else
1751  cat >ad_config.template <<EOF          mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
1752  C  WARNING: This file is automatically generated by genmake2 and          mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1753  C    used by the Makefile rules.  Please DO NOT EDIT this file      fi
1754  C    unless you are CERTAIN that you know what you are doing.  fi
1755    if test ! -f AD_CONFIG.h ; then
1756  #define ALLOW_ADJOINT_RUN      $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
1757  #undef ALLOW_TANGENTLINEAR_RUN  fi
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >ftl_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #define ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >svd_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #undef ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cp AD_CONFIG.template AD_CONFIG.h  
1758    
1759    
1760  #  Write the "state" for future records  #  Write the "state" for future records

Legend:
Removed from v.1.32  
changed lines
  Added in v.1.61

  ViewVC Help
Powered by ViewVC 1.1.22